<!doctype html>
<html lang="en">
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<meta charset="UTF-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Modular 3D Scanner Toolkit</title>
	<link rel="stylesheet" type="text/css" href="css/demo.css" />
</head>

<body class="hideBody">
	<div class="container-main">
		<div class="container-menu">
			<h1>Modular 3D Scanner Toolkit</h1>
			<div class="buttons">

				<h2 class="about"> > about</h2>
			
				<h2 class="roadmap"> > roadmap</h2>
			
				<h2 class="process"> > process</h2>

				<h2 id="mobileHideImages" class="images"> > videos</h2>
			
			</div>

		</div>
		<div class="container-text">
			<div class="text">
				<div class="about">
					<h1>about</h1>
					<p>Modular 3D Scanner Toolkit is a custom built software that allows to capture various objects, creatures and spaces as 3D models in near real-time. The aim of the toolkit is to make it easier to combine views from multiple depth cameras into a seamless pointcloud and to enable further experiments with 3D scanning things in motion. It is designed and developed by <a href="https://pointer.click" target="_blank">Studio Pointer*</a> and was originally created as part of interactive art installation Planet of People, most recently exhibited at Venice Architecture Biennale 2021 where it was presented by <a href="https://lithuanianspace.agency" target="_blank">the Lithuanian Space Agency</a> (the Lithuanian Pavilion). After working on multiple iterations of the software, studio Pointer* decided that this tool can be useful for other artists and developers and that the best future for it is to be open source and out in the world. </p>
				</div>
				
				<div class="roadmap marked">
# roadmap
<span class="legend"><span class='greenLeg'> ● - implemented</span><br><span class='redLeg'> ● - to be implemented</span></span>
- [x] tested systems
    - [x] Linux 64bit >= 5.3.x
        - [x] Ubuntu 18.04
        - [x] Ubuntu 20.04
        - [x] Debian 10
        - [x] Debian 11
        - [x] Manjaro (Arch)
    - [x] GPU
        - [x] Nvidia 1070/1080/1080TI/3070
        - [x] AMD Radeon 6600
- [x] devices
    - [x] Azure Kinect
    - [ ] Realsense D415/D435/etc
- [x] functionality
    - [x] create or modify openFrameworks addons
        - [x] openFrameworks
            - [x] add cpp17 on linux
        - [x] ofxPCL
            - [x] installation script
            - [ ] examples
        - [x] ofxDepthDevice
            - [x] Kinect Azure SDK wrapper and implementation
            - [ ] Realsense SDK wrapper and implementation
            - [x] multi-threaded depth streaming (per camera or per task)
            - [x] installation script
            - [x] examples
        - [x] ofxCv*
            - [x] installation script
            - [x] add Aruco/chAruco
            - [x] marker pose detection
            - [x] examples
    - [x] scanner
        - [x] calibration
            - [x] rough manual calibration
            - [x] rough calibration with markers
            - [x] fine calibration by point cloud shape
            - [x] export camera poses
                - [x] json array per calibration method
                - [ ] openCV style yaml
                - [ ] Blender, Godot, Unity, UE4 transfomation nodes
        - [x] simultaneous capture of scan
        - [x] scan optimization
            - [x] calculation of normals
            - [x] automatized cleanup
            - [x] adjustable levels of detail (model resolutions)
            - [ ] textured mesh
            - [ ] internal human skeleton detection
        - [x] Wavefront obj output
        - [ ] assimp
    - [x] human skeleton detection
        - [x] openpose docker
        - [x] python script skeleton from wavefront obj
        <br><br>
				</div>
			
				<div class="process marked">
# process
The toolkit can be used either as a scanner application for Linux, or an openFramworks plugin.

We are aiming to provide a precompiled package of the application soon, but for now you would need to compile it yourself and some knowledge of openFrameworks and Linux is useful.

## Using the openFrameworks plugin:
You'll find the plugin and a short readme with installation instructions here:
[https://gitlab.com/pointerstudio/utils/ofxdepthdevice](https://gitlab.com/pointerstudio/utils/ofxdepthdevice)

It has been successfully tested with various distributions. The plugin is in constant development, but can be considered stable. Our maximum non-stop uptime was 221 days with six cameras on one machine.
Theoretically it should also run on Windows, but we have not tested it.

## Using the scanner application for Linux
You'll find the application and instructions to build it here:
[https://gitlab.com/pointerstudio/depthdevice/scanner](https://gitlab.com/pointerstudio/depthdevice/scanner)

This application implements multiple calibration techniques and is able to produce a merged and optimized pointcloud model. At the moment of writing, the usage is rather functional and not user friendly. Any suggestions for improvement are welcome.
				</div>


				<div class="support">
					<p>Special thanks to Fred Rodrigues</p>
					<p> This project is made possible thanks to support from <a href="https://stimuleringsfonds.nl/en/" target="_blank">Stimuleringsfonds</a></p>
					<video width="300" autoplay muted loop preload playsinline>
					  <source src="logos/logo.mp4" type="video/mp4">
					Your browser does not support the video tag.
					</video>
					<br>
					
				</div>
			</div>
			<div class="images">
				<div class="container-media">
					<div class="container-video">
						<video autoplay muted loop preload playsinline>
						  <source src="media/scannersingle/1-smaller.mp4" type="video/mp4">
						Your browser does not support the video tag.
						</video>
						<!-- <p class="fig">fig.1</p> -->
					</div>
					<div class="container-video">
						<video autoplay muted loop preload playsinline>
						  <source src="media/scannersingle/2-smaller.mp4" type="video/mp4">
						Your browser does not support the video tag.
						</video>
						<!-- <p class="fig">fig.2</p> -->
					</div>
					<div class="container-video">
						<video autoplay muted loop preload playsinline>
						  <source src="media/scannersingle/4-smaller.mp4" type="video/mp4">
						Your browser does not support the video tag.
						</video>
						<!-- <p class="fig">fig.2</p> -->
					</div>
					<div class="container-video">
						<video autoplay muted loop preload playsinline>
						  <source src="media/scannersingle/3-smaller.mp4" type="video/mp4">
						Your browser does not support the video tag.
						</video>
						<!-- <p class="fig">fig.2</p> -->
					</div>
					<div class="container-video">
						<video autoplay muted loop preload playsinline>
						  <source src="media/scannersingle/5-smaller.mp4" type="video/mp4">
						Your browser does not support the video tag.
						</video>
						<!-- <p class="fig">fig.2</p> -->
					</div>

					<!-- <p class="caption"></p> -->
				</div>
			</div>
		</div>
	</div>


	<div class="jumpRotator">
           <svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"viewBox="0 0 27.97 26.53" style="enable-background:new 0 0 27.97 26.53;" xml:space="preserve">
                <g>
                    <path d="M1.29,7.75l10.41,3.8l-0.99,3.04L0,11.55L1.29,7.75z M4.1,24.17l6.84-8.66l2.58,1.82l-6.16,9.2L4.1,24.17z M16.04,0
                        l-0.38,11.1h-3.27L12.01,0H16.04z M20.67,26.53l-6.23-9.2l2.66-1.82l6.76,8.66L20.67,26.53z M27.97,11.55l-10.64,3.04l-0.99-3.04
                        l10.41-3.8L27.97,11.55z"/>
                </g>
            </svg>
    </div>

</body>


<script src="js/jquery.min.js"></script>
<script src="js/marked.min.js"></script>
<script src="js/script2.js"></script>
</html>
